<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfModoPagamentoERP ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfModoPagamentoERP
 * @subpackage Arrays
 */
class ArrayOfModoPagamentoERP extends AbstractStructArrayBase
{
    /**
     * The ModoPagamentoERP
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ModoPagamentoERP[]
     */
    public $ModoPagamentoERP;
    /**
     * Constructor method for ArrayOfModoPagamentoERP
     * @uses ArrayOfModoPagamentoERP::setModoPagamentoERP()
     * @param \StructType\ModoPagamentoERP[] $modoPagamentoERP
     */
    public function __construct(array $modoPagamentoERP = array())
    {
        $this
            ->setModoPagamentoERP($modoPagamentoERP);
    }
    /**
     * Get ModoPagamentoERP value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ModoPagamentoERP[]|null
     */
    public function getModoPagamentoERP()
    {
        return isset($this->ModoPagamentoERP) ? $this->ModoPagamentoERP : null;
    }
    /**
     * Set ModoPagamentoERP value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ModoPagamentoERP[] $modoPagamentoERP
     * @return \ArrayType\ArrayOfModoPagamentoERP
     */
    public function setModoPagamentoERP(array $modoPagamentoERP = array())
    {
        foreach ($modoPagamentoERP as $arrayOfModoPagamentoERPModoPagamentoERPItem) {
            // validation for constraint: itemType
            if (!$arrayOfModoPagamentoERPModoPagamentoERPItem instanceof \StructType\ModoPagamentoERP) {
                throw new \InvalidArgumentException(sprintf('The ModoPagamentoERP property can only contain items of \StructType\ModoPagamentoERP, "%s" given', is_object($arrayOfModoPagamentoERPModoPagamentoERPItem) ? get_class($arrayOfModoPagamentoERPModoPagamentoERPItem) : gettype($arrayOfModoPagamentoERPModoPagamentoERPItem)), __LINE__);
            }
        }
        if (is_null($modoPagamentoERP) || (is_array($modoPagamentoERP) && empty($modoPagamentoERP))) {
            unset($this->ModoPagamentoERP);
        } else {
            $this->ModoPagamentoERP = $modoPagamentoERP;
        }
        return $this;
    }
    /**
     * Add item to ModoPagamentoERP value
     * @throws \InvalidArgumentException
     * @param \StructType\ModoPagamentoERP $item
     * @return \ArrayType\ArrayOfModoPagamentoERP
     */
    public function addToModoPagamentoERP(\StructType\ModoPagamentoERP $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ModoPagamentoERP) {
            throw new \InvalidArgumentException(sprintf('The ModoPagamentoERP property can only contain items of \StructType\ModoPagamentoERP, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ModoPagamentoERP[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ModoPagamentoERP|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ModoPagamentoERP|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ModoPagamentoERP|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ModoPagamentoERP|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ModoPagamentoERP|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ModoPagamentoERP
     */
    public function getAttributeName()
    {
        return 'ModoPagamentoERP';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfModoPagamentoERP
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
